import React, { useState } from 'react';
import { dispatch } from '../../../domain/gameStore';
import ClickMarkerMap from './ClickMarkerMap';
import styles from './GamePanel.module.css';
import RoundTimer from './RoundTimer';

export default () => {
  const [ selectedPoint, setSelectedPoint ] = useState(null);
  const [ submitted, setSubmitted ] = useState(false);

  const handleSubmitGuess = async () => {
    setSubmitted(true);
    if (!submitted) {
      await dispatch.submitGuess(selectedPoint);
    }
  };

  return (
    <div className={styles.guess}>
      <div className={styles.map}>
        <ClickMarkerMap onMarkerMoved={setSelectedPoint} />
      </div>
      <div className={styles.submit}>
        <RoundTimer onTimeout={handleSubmitGuess} />
        <button
          className={styles.submitButton}
          onClick={handleSubmitGuess}
          disabled={submitted || selectedPoint === null}
        >
          Submit Guess
        </button>
      </div>
    </div>
  );
};
